import { U as Union$1 } from '../../dist/entity-7cff441b.esm.js';
export { a as Entity } from '../../dist/entity-7cff441b.esm.js';
import { defaultMetadataStorage } from 'class-transformer/cjs/storage.js';

/* eslint-disable @typescript-eslint/no-var-requires */
const camelCase = require("lodash/camelCase");
const snakeCase = require("lodash/snakeCase");
function ExposeAll(options) {
  const {
    nameCasing
  } = options || {};
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  return function (target) {
    const object = new target();
    Object.entries(object).forEach(([key]) => {
      const exists = defaultMetadataStorage.findExposeMetadata(target, key);
      if (exists) return;
      const options = {};
      switch (nameCasing) {
        case "camelCase":
          options.name = camelCase(key);
          break;
        case "snakeCase":
          options.name = snakeCase(key);
          break;
      }
      defaultMetadataStorage.addExposeMetadata({
        target: target,
        propertyName: key,
        options
      });
    });
  };
}

function Union({
  discriminatorProperty = "type",
  subTypes = []
}) {
  return function (target, propertyKey) {
    const reflectedType = Reflect.getMetadata("design:type", target, propertyKey);
    defaultMetadataStorage.addTypeMetadata({
      target: target.constructor,
      propertyName: propertyKey,
      reflectedType,
      typeFunction: () => Union$1,
      options: {
        discriminator: {
          property: discriminatorProperty,
          subTypes
        }
      }
    });
    if (reflectedType.name === "Array") {
      defaultMetadataStorage.addTransformMetadata({
        target: target.constructor,
        propertyName: propertyKey,
        transformFn: ({
          value
        }) => value?.filter(v => !(v instanceof Union$1)),
        options: {}
      });
    }
  };
}

export { ExposeAll, Union };
